/* f2c.h  --  Standard Fortran to C header file */

/**  barf  [ba:rf]  2.  "He suggested using FORTRAN, and everybody barfed."

	- From The Shogakukan DICTIONARY OF NEW ENGLISH (Second edition) */

#ifndef F2C_INCLUDE
#define F2C_INCLUDE

#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

typedef int integer;
typedef unsigned int uinteger;
typedef char *address;
typedef short int shortint;
typedef float real;
typedef double doublereal;
typedef struct { real r, i; } complex;
typedef struct { doublereal r, i; } doublecomplex;
typedef int logical;
typedef short int shortlogical;
typedef char logical1;
typedef char integer1;

#define TRUE_ (1)
#define FALSE_ (0)

/* Extern is for use with -E */
#ifndef Extern
#define Extern extern
#endif

/* I/O stuff */

typedef int flag;
typedef int ftnlen;
typedef int ftnint;

/*external read, write*/
typedef struct
{	flag cierr;
	ftnint ciunit;
	flag ciend;
	char *cifmt;
	ftnint cirec;
} cilist;

/*internal read, write*/
typedef struct
{	flag icierr;
	char *iciunit;
	flag iciend;
	char *icifmt;
	ftnint icirlen;
	ftnint icirnum;
} icilist;

/*open*/
typedef struct
{	flag oerr;
	ftnint ounit;
	char *ofnm;
	ftnlen ofnmlen;
	char *osta;
	char *oacc;
	char *ofm;
	ftnint orl;
	char *oblnk;
} olist;

/*close*/
typedef struct
{	flag cerr;
	ftnint cunit;
	char *csta;
} cllist;

/*rewind, backspace, endfile*/
typedef struct
{	flag aerr;
	ftnint aunit;
} alist;

/* inquire */
typedef struct
{	flag inerr;
	ftnint inunit;
	char *infile;
	ftnlen infilen;
	ftnint	*inex;	/*parameters in standard's order*/
	ftnint	*inopen;
	ftnint	*innum;
	ftnint	*innamed;
	char	*inname;
	ftnlen	innamlen;
	char	*inacc;
	ftnlen	inacclen;
	char	*inseq;
	ftnlen	inseqlen;
	char 	*indir;
	ftnlen	indirlen;
	char	*infmt;
	ftnlen	infmtlen;
	char	*inform;
	ftnint	informlen;
	char	*inunf;
	ftnlen	inunflen;
	ftnint	*inrecl;
	ftnint	*innrec;
	char	*inblank;
	ftnlen	inblanklen;
} inlist;

#define VOID void

union Multitype {	/* for multiple entry points */
	integer1 g;
	shortint h;
	integer i;
	/* longint j; */
	real r;
	doublereal d;
	complex c;
	doublecomplex z;
	};

typedef union Multitype Multitype;

struct Vardesc {	/* for Namelist */
	char *name;
	char *addr;
	ftnlen *dims;
	int  type;
	};
typedef struct Vardesc Vardesc;

struct Namelist {
	char *name;
	Vardesc **vars;
	int nvars;
	};
typedef struct Namelist Namelist;

#define abs(x) ((x) >= 0 ? (x) : -(x))
#define dabs(x) (abs(x))
#define min(a,b) ((a) <= (b) ? (a) : (b))
#define max(a,b) ((a) >= (b) ? (a) : (b))
#define dmin(a,b) (min(a,b))
#define dmax(a,b) (max(a,b))
#define bit_test(a,b)	((a) >> (b) & 1)
#define bit_clear(a,b)	((a) & ~((uinteger)1 << (b)))
#define bit_set(a,b)	((a) |  ((uinteger)1 << (b)))

#define abort_() { sig_die("Fortran abort routine called", 1); }
#define c_abs(z) ( (double)f__cabs( (z)->r, (z)->i ) )
extern double f__cabs(double real, double imag);
#define c_cos(R,Z) {(R)->r = (real)(cos((double)(Z)->r) * cosh((double)(Z)->i)); (R)->i = (real)(-sin((double)(Z)->r) * sinh((double)(Z)->i));}
#define c_div(c, a, b) { 	double ratio, den; 	double abr, abi, cr; 	if( (abr = (b)->r) < 0.) 		abr = - abr; 	if( (abi = (b)->i) < 0.) 		abi = - abi; 	if( abr <= abi ) 		{ 		if(abi == 0) 			sig_die("complex division by zero", 1); 		ratio = (double)(b)->r / (b)->i ; 		den = (b)->i * (1 + ratio*ratio); 		cr = ((a)->r*ratio + (a)->i) / den; 		(c)->i = ((a)->i*ratio - (a)->r) / den; 		} 	else 		{ 		ratio = (double)(b)->i / (b)->r ; 		den = (b)->r * (1 + ratio*ratio); 		cr = ((a)->r + (a)->i*ratio) / den; 		(c)->i = ((a)->i - (a)->r*ratio) / den; 		} 	(c)->r = cr; 	}
#define c_exp(R, Z) {(R)->r = (real)(exp((double)(Z)->r) * cos((double)(Z)->i)); (R)->i = (real)(exp((double)(Z)->r) * sin((double)(Z)->i)); }
#define c_log(R, Z) { (R)->i = (real)atan2((double)(Z)->i, (double)(Z)->r); (R)->r = (real)log( f__cabs((double)(Z)->r, (double)(Z)->i) ); }
#define c_sin(R, Z) { (R)->r = (real)(sin((double)(Z)->r) * cosh((double)(Z)->i)); (R)->i = (real)(cos((double)(Z)->r) * sinh((double)(Z)->i)); }
#define c_sqrt(R, Z) { 	double mag, t; 	double zi = (Z)->i, zr = (Z)->r; 	if( (mag = f__cabs(zr, zi)) == 0.) 		(R)->r = (R)->i = 0.; 	else if(zr > 0) 		{ 		(R)->r = t = sqrt(0.5 * (mag + zr) ); 		t = zi / t; 		(R)->i = 0.5 * t; 		} 	else 		{ 		t = sqrt(0.5 * (mag - zr) ); 		if(zi < 0) 			t = -t; 		(R)->i = t; 		t = zi / t; 		(R)->r = 0.5 * t; 		} 	}
#define d_abs(x) ((*(x) >= 0)?(*(x)):(- *(x)))
#define d_acos(x) (acos(*(x)))
#define d_asin(x) (asin(*(x)))
#define d_atan(x) (atan(*(x)))
#define d_atn2(x, y) (atan2(*(x),*(y)))
#define d_cnjg(R, Z) { (R)->r = (Z)->r;	(R)->i = -((Z)->i); }
#define d_cos(x) (cos(*(x)))
#define d_cosh(x) (cosh(*(x)))
#define d_dim(a, b) ( *(a) > *(b) ? *(a) - *(b) : 0)
#define d_exp(x) (exp(*(x)))
#define d_imag(z) ((z)->i)
#define d_int(x) ( (*(x)>0) ? floor(*(x)) : -floor(- *(x)) )
#define d_lg10(x) ( 0.43429448190325182765 * log(*(x)) )
#define d_log(x) (log(*(x)))
#define d_mod(x, y) (fmod(*(x), *(y)))
#define d_nint(x) ( (*(x))>=0 ? floor(*(x) + .5) : -floor(.5 - *(x)) )
#define d_prod(x,y) ( (*(x)) * (*(y)) )
#define d_sign(a,b) ( *(b) >= 0 ? (*(a) >= 0 ? *(a) : - *(a)) : -(*(a) >= 0 ? *(a) : - *(a)))
#define d_sin(x) (sin(*(x)))
#define d_sinh(x) (sinh(*(x)))
#define d_sqrt(x) (sqrt(*(x)))
#define d_tan(x) (tan(*(x)))
#define d_tanh(x) (tanh(*(x)))
#define i_abs(x) ((*(x) >= 0)? (*(x)): (- *(x)))
#define i_dnnt(x) ((integer)(*(x) >= 0. ? floor(*(x) + .5) : -floor(.5 - *(x))))
#define i_len(s, n) (n)
#define i_nint(x) ((integer)(*(x) >= 0 ? floor(*(x) + .5) : -floor(.5 - *(x))))
#define i_sign(a,b) ( *(b) >= 0 ? (*(a) >= 0 ? *(a) : - *(a)) : -(*(a) >= 0 ? *(a) : - *(a)))
#define pow_ci(p, a, b) { pow_zi((p), (a), (b)); }
#define pow_dd(ap, bp) ((double)pow(*(ap), *(bp)))
#define pow_di(B,E) ((double)pow((double)*(B),(double)*(E)))
#define pow_ii(B,E)    ((integer)pow((double)*(B),(double)*(E)))
#define pow_ri(B,E) (pow((double)*(B),(double)*(E)))
#define pow_zi(p, a, b) { doublecomplex cb; cb.r = *(b); cb.i = 0.0; pow_zz((p), (a), &cb); }
#define pow_zz(R,A,B) { double logr, logi, x, y; logr = log( f__cabs((A)->r, (A)->i) ); logi = atan2((A)->i, (A)->r); x = exp( logr * (B)->r - logi * (B)->i ); y = logr * (B)->i + logi * (B)->r; (R)->r = x * cos(y); (R)->i = x * sin(y); }
#define r_cnjg(R, Z) { (R)->r = (Z)->r;	(R)->i = -((Z)->i); }
#define r_imag(z) ((z)->i)
#define r_lg10(x) ( 0.43429448190325182765 * log((double)*(x)) )
#define r_sign(a,b) ( *(b) >= 0 ? (*(a) >= 0 ? *(a) : - *(a)) : -(*(a) >= 0 ? *(a) : - *(a)))
#define s_cat(lpp, rpp, rnp, np, llp) { 	ftnlen i, nc, ll; char *f__rp, *lp; 	ll = (llp); lp = (lpp); 	for(i=0; i < (int)*(np); ++i) {         	nc = ll; 	        if((rnp)[i] < nc) nc = (rnp)[i]; 	        ll -= nc;         	f__rp = (rpp)[i]; 	        while(--nc >= 0) *lp++ = *(f__rp)++;         } 	while(--ll >= 0) *lp++ = ' '; }
#define s_cmp(a,b,c,d) strncmp((a),(b),min((c),(d)))
#define s_copy(A,B,C,D) strncpy((A),(B),min((C),(D)))
#define sig_die(s, kill) { exit(1); }
#define s_stop(s, n) {exit(0);}
#define z_abs(z) (f__cabs( (z)->r, (z)->i ) )
void z_div(doublecomplex *c, doublecomplex *a, doublecomplex *b);
#define z_exp(R, Z) { (R)->r = exp((Z)->r) * cos((Z)->i); (R)->i = exp((Z)->r) * sin((Z)->i); }
void z_sqrt(doublecomplex *r, doublecomplex *z);

/* procedure parameter types for -A and -C++ */

#define F2C_proc_par_types 1
#ifdef __cplusplus
typedef int /* Unknown procedure type */ (*U_fp)(...);
typedef shortint (*J_fp)(...);
typedef integer (*I_fp)(...);
typedef real (*R_fp)(...);
typedef doublereal (*D_fp)(...), (*E_fp)(...);
typedef /* Complex */ VOID (*C_fp)(...);
typedef /* Double Complex */ VOID (*Z_fp)(...);
typedef logical (*L_fp)(...);
typedef shortlogical (*K_fp)(...);
typedef /* Character */ VOID (*H_fp)(...);
typedef /* Subroutine */ int (*S_fp)(...);
#else
typedef int /* Unknown procedure type */ (*U_fp)();
typedef shortint (*J_fp)();
typedef integer (*I_fp)();
typedef real (*R_fp)();
typedef doublereal (*D_fp)(), (*E_fp)();
typedef /* Complex */ VOID (*C_fp)();
typedef /* Double Complex */ VOID (*Z_fp)();
typedef logical (*L_fp)();
typedef shortlogical (*K_fp)();
typedef /* Character */ VOID (*H_fp)();
typedef /* Subroutine */ int (*S_fp)();
#endif
/* E_fp is for real functions when -R is not specified */
typedef VOID C_f;	/* complex function */
typedef VOID H_f;	/* character function */
typedef VOID Z_f;	/* double complex function */
typedef doublereal E_f;	/* real function with -R not specified */

/* undef any lower-case symbols that your C compiler predefines, e.g.: */

#endif
